import info.lotosummary.software.*;
import java.io.*;

/*
Zoko Java Version 1.04
Finding Loto-7 winners
Copyright 2017 Sogaya

JDK 1.8.0

*/

public class Zoko {
    static final double VERSION = 1.04;
    static final int BALLS = 4;
    static final int ERROR_CODE = 1;
    static final int MANAGE_TEXT_LINE_COUNT = 10;
    static final int NOT_CONVERTED = -1;
    static final int UNASSIGNED = -1;
    static final String BEIGE = "-be";
    static final String BLUE = "-bl";
    static final String BONUS = "-b";
    static final String BONUS_3 = "-c3b";
    static final String BONUS_6 = "-c6b";
    static final String COUNT = "-c";
    static final String CSV = "--csv";
    static final String DRAFO_CSV = "drafo.csv";
    static final String EMPTY = "";
    static final String ERROR_TEXT = "error.txt";
    static final String EXCLUDE = "-e";
    static final String EXCLUDE_TEXT = "exclude.txt";
    static final String GREEN = "-gr";
    static final String MANAGE_TEXT = "manage.txt";
    static final String MARK = "-m";
    static final String NAVY = "-na";
    static final String NO_EDITING = "-e-";
    static final String NO_ERROR = "No error";
    static final String NO_PREEDITING = "-p-";
    static final String NO_REMOVING = "-r-";
    static final String NO_SPLITTING = "-s-";
    static final String OVERWRITE = "-o";
    static final String PURPLE = "-pu";
    static final String QUIT = "-q";
    static final String RED = "-re";
    static final String REMOVE_ERROR_TEXT = "remove_e.txt";
    static final String REMOVE_LINE_1 = "-1-";
    static final String SEPARATE_TEXT = "separate.txt";
    static final String TABLE = "-a";
    static final String THREE_LINES_UNITED = "-3";
    static final String VERSION_COMMENTS = "-VC";
    static final String VERSION_GUIDE = "-V";
    static final String WHO_TEXT = "who.txt";
    static final String YELLOW = "-ye";
    static final String Z_MISSING_BONUS = "-z";
    static final String ZERO = "0";

    static boolean firstLine, noSplitting, preedit, serialNumber, threeLinesUnited, whoText;
    static int balls, NEW_LINE_LENGTH, rowCount;
    static String fileName, error, FULL_PATH_NAME, list_of_items, NEW_LINE;

    static String[] m = {
             "", // m[0], FULL_PATH_NAME includes MANAGE_TEXT.
      "who.txt", // m[1], fileName
  "exclude.txt", // m[2], list_of_items
            "4", // m[3], balls
            "1", // m[4], firstLine
            "0", // m[5], noSplitting
            "1", // m[6], preedit
         "5000", // m[7], rowCount
            "1", // m[8], serialNumber
            "0", // m[9], whoText
            "0"  // m[10], threeLinesUnited
        };

    private static boolean createErrorText(String messages) {
        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(ERROR_TEXT) );
            file.write(messages); file.newLine();
            file.close();
            return true;
        } catch(Exception e30) {
            error = "Exception e30: " + ERROR_TEXT;
            return false;
        }

    }

    private static boolean readManageText() {
        m[0] = FULL_PATH_NAME;

        try {
            BufferedReader buffered = new BufferedReader( new FileReader(FULL_PATH_NAME) );
            for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1) {
                m[line] = buffered.readLine();
                if(m[line] == null) {
                    break;
                }

            }

            buffered.close();
            return true;
        } catch(IOException e29) {
            error = "IOException e29: " + FULL_PATH_NAME;
            createErrorText(error);
            return false;
        }

    }

    public static boolean testDrafoCsv() {
        boolean result;

        try {
            BufferedReader test = new BufferedReader( new FileReader(DRAFO_CSV) );
            test.close();
            result = true;
            return result;
        } catch(IOException e31) {
            result = false;
        }

        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(DRAFO_CSV) );
            file.write("&#160;, ,"); file.newLine();
            file.write("&nbsp;, ,"); file.newLine();
            file.write("a,A,"); file.newLine();
            file.write("l,L,"); file.newLine();
            file.write("p,P,"); file.newLine();
            file.write("q,Q,"); file.newLine();
            file.write("\\,, ,"); file.newLine();
            file.write("., ,"); file.newLine();
            file.write("      , ,"); file.newLine();
            file.write("     , ,"); file.newLine();
            file.write("    , ,"); file.newLine();
            file.write("   , ,"); file.newLine();
            file.write("  , ,"); file.newLine();
            file.write(" 1 , 01 ,"); file.newLine();
            file.write(" 2 , 02 ,"); file.newLine();
            file.write(" 3 , 03 ,"); file.newLine();
            file.write(" 4 , 04 ,"); file.newLine();
            file.write(" 5 , 05 ,"); file.newLine();
            file.write(" 6 , 06 ,"); file.newLine();
            file.write(" 7 , 07 ,"); file.newLine();
            file.write(" 8 , 08 ,"); file.newLine();
            file.write(" 9 , 09 ,"); file.newLine();
            file.write("ALLQP,ALL QP,"); file.newLine();
            file.write("|,/,"); file.newLine();
            file.close();
            return result;
        } catch(Exception e33) {
            return result;
        }

    }

    public static boolean testExcludeText() {
        boolean result;

        try {
            BufferedReader test = new BufferedReader( new FileReader(EXCLUDE_TEXT) );
            test.close();
            result = true;
            return result;
        } catch(IOException e11) {
            result = false;
        }

        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(EXCLUDE_TEXT) );
            file.write("ʂ"); file.newLine(); // Shift_JIS
            file.write(" ID:"); file.newLine();
            file.close();
            return result;
        } catch(IOException e15) {
            return result;
        }

    }

    public static boolean testSeparateText() {
        boolean result;

        try {
            BufferedReader test = new BufferedReader( new FileReader(SEPARATE_TEXT) );
            test.close();
            result = true;
            return result;
        } catch(IOException e16) {
            result = false;
        }

        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(SEPARATE_TEXT) );
            file.write("/"); file.newLine();
            file.write("|"); file.newLine();
            file.close();
            return result;
        } catch(IOException e32) {
            return result;
        }

    }

    private static int integerFromString(String s) {
        int result;

        try {
            result = Integer.parseInt(s);
            return result;
        } catch(NumberFormatException e24) {
            error = "NumberFormatException e24";
            return NOT_CONVERTED;
        }

    }

    private static String[] driveDirectoryBase(String s) {
        int firstTrace, trace, w;
        int s_length = s.length();
        String c;
        String SLASH = "/";
        String YEN = "\\";
        String SEPARATOR = YEN;
        String[] part = {"", "", "", "", ""};
        String[] UNDIVIDED = {"", "", "", "", ""};

        part[0] = s; // s.length > 0; in other words, part[0].length > UNDIVIDED[0].length

// s is divided into three parts: drive name, directory name, and base name.
        int k = 0;
        for( ; k < s_length; ++k) {
            c = s.substring(k, k + 1 );
            if( YEN.equals(c) ) {
                SEPARATOR = YEN;
                break;
            } else if( SLASH.equals(c) ) {
                SEPARATOR = SLASH;
                break;
            }

        }

        if(k == s_length) { // Neither YEN nor SLASH has been found.
            return UNDIVIDED;
        } else {
            w = k + 1;
            part[1] = s.substring(0, w); // C:\ for example
            trace = ++k;
            firstTrace = trace;
        }

        for( ; k < s_length; ++k) {
            c = s.substring(k, k + 1 );
            if( SEPARATOR.equals(c) ) {
                trace = ++k;
            }

        }

        part[2] = s.substring(firstTrace, trace);
        part[3] = s.substring(trace); // manage.txt for example
        part[4] = SEPARATOR;
        return part;
    }

    private static void guide(boolean comments) {
        if(comments) {
            System.err.println( "Zoko Java Version " + String.valueOf(VERSION) );
            System.err.println("");
            System.err.println("java Zoko -V               # version ");
            System.err.println("java Zoko -VC              # version with comments ");
            System.err.println("java Zoko who.txt -1-      # Remove Line-1. ");
            System.err.println("java Zoko who.txt -3       # Unite three lines to form a date Line. ");
            System.err.println("java Zoko who.txt -a       # Produce CSV files. ");
            System.err.println("java Zoko who.txt -b3      # Write if they match 3 balls and a bonus ball. ");
            System.err.println("java Zoko who.txt -be17    # beige ball-17 ");
            System.err.println("java Zoko who.txt -bl15    # blue ball-15 ");
            System.err.println("java Zoko who.txt -c3b     # Write if they match 3 balls and a bonus ball. ");
            System.err.println("java Zoko who.txt -c4      # Read who.txt and write if they match 4 balls. ");
            System.err.println("java Zoko who.txt -c6b     # Write if they match 6 balls and a bonus ball. ");
            System.err.println("java Zoko who.txt -e exclude.txt # Every nurupo resu is excluded from who.txt ");
            System.err.println("java Zoko who.txt -gr35    # green ball-35 ");
            System.err.println("java Zoko who.txt -m       # Show marking so that they can match seven balls. ");
            System.err.println("java Zoko who.txt -na34    # navy blue ball-34 ");
            System.err.println("java Zoko who.txt -o       # Overwrite who.txt ");
            System.err.println("java Zoko who.txt -p-      # Do not edit who.txt ");
            System.err.println("java Zoko who.txt -pu28    # purple ball-28 ");
            System.err.println("java Zoko who.txt -q       # Quit before finding. ");
            System.err.println("java Zoko who.txt -r-      # Do not remove temporary files. ");
            System.err.println("java Zoko who.txt -re15    # red ball-15 ");
            System.err.println("java Zoko who.txt -s-      # Do not split date lines. ");
            System.err.println("java Zoko who.txt -ye23    # yellow ball-23 ");
            System.err.println("java Zoko who.txt -z19-27  # Replace ball-19 with bonus ball-27. ");
        } else {
            System.err.println( "Zoko Java Version " + String.valueOf(VERSION) );
            System.err.println("");
            System.err.println("java Zoko -V               ");
            System.err.println("java Zoko -VC              ");
            System.err.println("java Zoko who.txt -1-      ");
            System.err.println("java Zoko who.txt -3       ");
            System.err.println("java Zoko who.txt -a       ");
            System.err.println("java Zoko who.txt -b3      ");
            System.err.println("java Zoko who.txt -be17    ");
            System.err.println("java Zoko who.txt -bl15    ");
            System.err.println("java Zoko who.txt -c3b     ");
            System.err.println("java Zoko who.txt -c4      ");
            System.err.println("java Zoko who.txt -c6b     ");
            System.err.println("java Zoko who.txt -e exclude.txt ");
            System.err.println("java Zoko who.txt -gr35    ");
            System.err.println("java Zoko who.txt -m       ");
            System.err.println("java Zoko who.txt -na34    ");
            System.err.println("java Zoko who.txt -o       ");
            System.err.println("java Zoko who.txt -p-      ");
            System.err.println("java Zoko who.txt -pu28    ");
            System.err.println("java Zoko who.txt -q       ");
            System.err.println("java Zoko who.txt -r-      ");
            System.err.println("java Zoko who.txt -re15    ");
            System.err.println("java Zoko who.txt -s-      ");
            System.err.println("java Zoko who.txt -ye23    ");
            System.err.println("java Zoko who.txt -z19-27  ");
        }

    }

    private static void removeTemporaryFiles() {
// Removing temporary files
        File file;
        String s;
        try {
            BufferedReader remove_e = new BufferedReader( new FileReader(REMOVE_ERROR_TEXT) );
            for(;;) {
                s = remove_e.readLine();
                if(s == null) {
                    break;
                } else if( WHO_TEXT.equals(s) ) {
                    continue;
                }

                file = new File(s);
                file.delete();
            }

            remove_e.close();
//            file = new File(REMOVE_ERROR_TEXT);
//            file.delete();
        } catch(IOException e36) {
            ;
        }

    }

    public Zoko() {
    }

    public static void main(String[] args) {
        boolean countBonus = false;
        boolean csv = false;
        boolean destroyWhoText= false;
        boolean mark = false;
        boolean quit = false;
        boolean removeFirst = true;
        boolean WITH_COMMENTS = true;
        boolean WITHOUT_COMMENTS = false;
        boolean[] provided = {true, true, true};
        int count = args.length;
        int q;
        int beige_number = UNASSIGNED;
        int blue_number = UNASSIGNED;
        int green_number = UNASSIGNED;
        int navy_number = UNASSIGNED;
        int providedSize = provided.length;
        int purple_number = UNASSIGNED;
        int red_number = UNASSIGNED;
        int yellow_number = UNASSIGNED;
        int z_bonus_number = UNASSIGNED;
        int z_missing_number = UNASSIGNED;
        Numbered n;
        String argument;

        error = NO_ERROR;
        fileName = WHO_TEXT;
        firstLine = true;
        balls = BALLS;
        list_of_items = EXCLUDE_TEXT;
        NEW_LINE = System.getProperty("line.separator");
        NEW_LINE_LENGTH = NEW_LINE.length();
        noSplitting = false;
        preedit = true;
        serialNumber = true;
        threeLinesUnited = false;
        whoText = true;

        provided[0] = testDrafoCsv();
        provided[1] = testExcludeText();
        provided[2] = testSeparateText();
        for(int i = 0; i < providedSize; ++i) {
            if(provided[i]) {
                continue;
            } else {
                System.exit(1);
            }

        }

// C:\ZokoJava\manage.txt for example
        String firstPart = System.getProperty("user.dir"); // current directory
        String[] name = {"", "", "", "", ""};
        name = driveDirectoryBase(firstPart);
        String root = name[1];
        String SEPARATOR = name[4];
        if(firstPart == root) { // C:\ for example
            FULL_PATH_NAME = root + MANAGE_TEXT;
        } else { // C:\ZokoJava for example 
            FULL_PATH_NAME = firstPart + SEPARATOR + MANAGE_TEXT;
        }

        File manage_text = new File(FULL_PATH_NAME);
        if( manage_text.exists() ) {
            readManageText();

            fileName = m[1];
            list_of_items = m[2];
            balls = integerFromString(m[3]);
            firstLine = ( ZERO.equals(m[4]) ) ? false : true;
            noSplitting = ( ZERO.equals(m[5]) ) ? false : true;
            preedit = ( ZERO.equals(m[6]) ) ? false : true;
            rowCount = integerFromString(m[7]);
            serialNumber = ( ZERO.equals(m[8]) ) ? false : true;
            destroyWhoText = ( ZERO.equals(m[9]) ) ? false : true;
            threeLinesUnited = ( ZERO.equals(m[10]) ) ? false : true;
        } else {
// Creating MANAGE_TEXT
            StringBuffer os = new StringBuffer();
            for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1 ) {
                os.append(m[line]);
                os.append(NEW_LINE);
            }

            String s = os.toString();
            try {
                BufferedWriter file = new BufferedWriter( new FileWriter(MANAGE_TEXT) );
                file.write(s);
                file.close();
            } catch(Exception e31) {
                error = "Exception e31: " + MANAGE_TEXT;
                createErrorText(error);
                System.exit(ERROR_CODE);
            }

        }

        int based_on_m3 = balls;
        for(int i = 0; i < count; ++i) {
            argument = args[i];

            if( BONUS_3.equals(argument) ) {
                balls = 3;
                countBonus = true;
            } else if( BONUS_6.equals(argument) ) {
                balls = 6;
                countBonus = true;
            } else if( CSV.equals(argument) ) {
                csv = true;
            } else if( EXCLUDE.equals(argument) ) {
                list_of_items = EXCLUDE_TEXT;
            } else if( MARK.equals(argument) ) {
                mark= true;
            } else if( NO_EDITING.equals(argument) ) {
                preedit = false;
            } else if( NO_PREEDITING.equals(argument) ) {
                preedit = false;
            } else if( NO_REMOVING.equals(argument) ) {
                removeFirst = false;
            } else if( NO_SPLITTING.equals(argument) ) {
                noSplitting = true;
            } else if( OVERWRITE.equals(argument) ) {
                destroyWhoText = true;
            } else if( QUIT.equals(argument) ) {
                quit = true;
            } else if( REMOVE_LINE_1.equals(argument) ) {
                firstLine = false;
            } else if( TABLE.equals(argument) ) {
                csv = true;
            } else if( THREE_LINES_UNITED.equals(argument) ) { // The web browser may divide a date line into three lines, which shall be united to form the date line.
                threeLinesUnited = true;
            } else if( VERSION_COMMENTS.equals(argument) ) {
                guide(WITH_COMMENTS);
                System.exit(1);

            } else if( VERSION_GUIDE.equals(argument) ) {
                guide(WITHOUT_COMMENTS);
                System.exit(1);

            } else {
                if(whoText) {
                    fileName = argument;
                    whoText = false;
                } else {
                    q = argument.indexOf(BEIGE);
                    if(q >= 0) {
                        n = new Numbered(argument);
                        beige_number = n.number();
                        if( BEIGE.equals( n.parameter() ) ) {
                            mark = true;
                            continue;
                        }

                        beige_number = UNASSIGNED;
                    }

                    q = argument.indexOf(BLUE);
                    if(q >= 0) {
                        n = new Numbered(argument);
                        blue_number = n.number();
                        if( BLUE.equals( n.parameter() ) ) {
                            mark = true;
                            continue;
                        }

                        blue_number = UNASSIGNED;
                    }

                    q = argument.indexOf(BONUS);
                    if(q >= 0) {
                        n = new Numbered(argument);
                        balls = n.number();
                        countBonus = true;
                        if( BONUS.equals( n.parameter() ) ) {
                            continue;
                        }

                        balls = based_on_m3;
                        countBonus = false;
                    }

                    q = argument.indexOf(COUNT);
                    if(q >= 0) {
                        n = new Numbered(argument);
                        balls = n.number();
                        if( COUNT.equals( n.parameter() ) ) {
                            continue;
                        }

                        balls = based_on_m3;
                    }

                    q = argument.indexOf(GREEN);
                    if(q >= 0) {
                        n = new Numbered(argument);
                        green_number = n.number();
                        if( GREEN.equals( n.parameter() ) ) {
                            mark = true;
                            continue;
                        }

                        green_number = UNASSIGNED;
                    }

                    q = argument.indexOf(NAVY);
                    if(q >= 0) {
                        n = new Numbered(argument);
                        navy_number = n.number();
                        if( NAVY.equals( n.parameter() ) ) {
                            mark = true;
                            continue;
                        }

                        navy_number = UNASSIGNED;
                    }

                    q = argument.indexOf(PURPLE);
                    if(q >= 0) {
                        n = new Numbered(argument);
                        purple_number = n.number();
                        if( PURPLE.equals( n.parameter() ) ) {
                            mark = true;
                            continue;
                        }

                        purple_number = UNASSIGNED;
                    }

                    q = argument.indexOf(RED);
                    if(q >= 0) {
                        n = new Numbered(argument);
                        red_number = n.number();
                        if( RED.equals( n.parameter() ) ) {
                            mark = true;
                            continue;
                        }

                        red_number = UNASSIGNED;
                    }

                    q = argument.indexOf(YELLOW);
                    if(q >= 0) {
                        n = new Numbered(argument);
                        yellow_number = n.number();
                        if( YELLOW.equals( n.parameter() ) ) {
                            mark = true;
                            continue;
                        }

                        yellow_number = UNASSIGNED;
                    }

                    q = argument.indexOf(Z_MISSING_BONUS);
                    if(q >= 0) {
                        n = new Numbered(argument);
                        z_bonus_number = n.number();
                        if( n.trimmed_sequence() ) {
                            z_missing_number = n.subnumber();
                            if( Z_MISSING_BONUS.equals( n.parameter() ) ) {
                                mark = true;
                                continue;
                            }

                        }

                        z_missing_number = UNASSIGNED;
                        z_bonus_number = UNASSIGNED;
                    }

                    list_of_items = argument;
                }

            }

        }

        if(removeFirst) {
            removeTemporaryFiles();
        }

        if(whoText) {
            ;
        } else {
            whoText = destroyWhoText;
        }

        if(mark) {
// Producing a text (see7654-32-10.txt, for example) which shows marks.
            try {
                BufferedReader buffered = new BufferedReader( new FileReader(fileName) );
                String LINE_1 = buffered.readLine();
                if(LINE_1 == null) {
                    error = "e62: LINE_1 == null";
                    System.err.println(error);
                }

                ManageMemo mm = new ManageMemo(LINE_1, beige_number, blue_number, green_number, navy_number, purple_number, red_number, yellow_number, z_bonus_number, z_missing_number);
                Mark m = new Mark(mm);
            } catch(IOException e11) {
                error = "IOException e11: " + WHO_TEXT;
                System.err.println(error);
            }

        } else {
            EditCount ec = new EditCount();
            ec.setting(FULL_PATH_NAME, fileName, list_of_items, balls, countBonus, csv, firstLine, noSplitting, preedit, quit, serialNumber, threeLinesUnited, whoText);
            if(quit) {
                if(preedit) {
                    ec.preediting();
                }

            } else {
// Preediting and counting to find Loto-7 winners
                ec.editCount();
            }

        }

    }

}
