/*
cou99 C-1.03
Copyright 2017 Sogaya
Counting two-digit numbers
If a number is less than 10, please add 0 to the number: 01, 02, ..., 09

Watcom

*/

#define VERSION 1.03
#define BUFFER_SIZE 128 /* BUFFER_SIZE > COLUMN_COUNT * NUMBER_SIZE + NEW_LINE_CHARACTER_SIZE + 1 */
#define COLUMN_COUNT 20
#define ERROR_TEXT "error.txt"
#define NEW_LINE_CHARACTER_SIZE 2 /* Windows (0Dh, 0Ah) */
#define NUMBER_SIZE 3 /* NUMBER_SIZE = strlen("37") + 1 */
#define RANNU_TEXT "rannu.txt"
#define TO_BUFFER_SIZE 384
#define TRUE 1
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

typedef int BOOL;
char buffer[BUFFER_SIZE];
int sparse[0x100][0x100];

int main(int argc, char *argv[]) {
    BOOL too_short = 0; /* FALSE */
    BOOL preedit = 0; /* FALSE */
    char *b0;
    char *b1;
    char *p;
    char *stop;
    char *ps[10];
    char s[10][2];
    const int c[10] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9'};
    FILE *file;
    int count, k, lineEnd, lineLength, m, n, standardLine, u, w;
    int columnCount = COLUMN_COUNT;

    switch(argc) {
    case 2:
        if(! strcmp(argv[1], "-V") ) {
            fprintf(stderr, "cou99 C-%1.2f\n\n", VERSION);
            fprintf(stderr, "cou99\n");
            fprintf(stderr, "cou99 -p file_name columns\n");
            fprintf(stderr, "cou99 -V\n");
            fprintf(stderr, "If a number is less than 10, please add 0 to the number: 01, 02, ..., 09\n");
            return 1;
        }

        break;
    case 4:
        if(! strcmp(argv[1], "-p") ) {
            preedit = preediting(argv[2]);
            if(preedit) {
                columnCount = (int)strtol(argv[3], &stop, 10);
            } else {
                return 1;
            }

        } else {
            return 1;
        }

        break;
    default:
        break;
    }

    file = fopen(RANNU_TEXT, "rt");
    if(file == NULL) {
        fputs(RANNU_TEXT, stderr);
        fputs("\n", stderr);
        return 1;
    }

    standardLine = columnCount * NUMBER_SIZE + 1;
    for(;;) {
        p = fgets(buffer, BUFFER_SIZE, file);
        if(p == NULL) {
            too_short = 0; /* FALSE */
            break;
        }

        lineLength = strlen(buffer);
        if(lineLength == standardLine) {
            b0 = & buffer[0];
            b1 = & buffer[1];
            for(k = 0; k < columnCount; ++k) {
/* Accessing and incrementing the matrix element */
                count = sparse[ *b0 ][ *b1 ];
                sparse[ *b0 ][ *b1 ] = count + 1;

                b0 += NUMBER_SIZE;
                b1 += NUMBER_SIZE;
            }

        } else {
            too_short = TRUE;
            break;
        }

    }

    if(too_short) {
        lineEnd = 0; /* FALSE */

        b0 = & buffer[0];
        b1 = & buffer[1];
        for(n = 0; n < columnCount; ++n) {
/* Accessing and incrementing the matrix element */
            count = sparse[ *b0 ][ *b1 ];
            sparse[ *b0 ][ *b1 ] = count + 1;
            for(m = 0; m < NUMBER_SIZE; ++m) {
                ++b0;
                if(*b0 == '\0') {
                    lineEnd = TRUE;
                    break;
                }

                ++b1;
                if(*b1 == '\0') {
                    lineEnd = TRUE;
                    break;
                }

            }

            if(lineEnd) {
                break;
            }

        }

    }

/* Displaying */
    ps[0] = & s[0][0]; strcpy(ps[0], "0");
    ps[1] = & s[1][0]; strcpy(ps[1], "1");
    ps[2] = & s[2][0]; strcpy(ps[2], "2");
    ps[3] = & s[3][0]; strcpy(ps[3], "3");
    ps[4] = & s[4][0]; strcpy(ps[4], "4");
    ps[5] = & s[5][0]; strcpy(ps[5], "5");
    ps[6] = & s[6][0]; strcpy(ps[6], "6");
    ps[7] = & s[7][0]; strcpy(ps[7], "7");
    ps[8] = & s[8][0]; strcpy(ps[8], "8");
    ps[9] = & s[9][0]; strcpy(ps[9], "9");
    for(u = 0; u < 10; ++u) { 
        for(w = 0; w < 10; ++w) { 
            fprintf(stdout, "%s%s: %d\n", ps[u], ps[w], sparse[ c[u] ][ c[w] ]);
        }

    }

    fclose(file);
    return 0;
}

int preediting(char *file_name) {
    char *p;
    char c[TO_BUFFER_SIZE];
    char to[TO_BUFFER_SIZE];
    const int NUMBER_COUNT = 8; /* ANNUY_TEXT */
    FILE *file;
    FILE *text;

    text = fopen(file_name, "rt");
    if(file == NULL) {
        fputs(file_name, stderr);
        fputs("\n", stderr);
        return 0; /* FALSE */
    }

    file = fopen(RANNU_TEXT, "wt");
    if(file == NULL) {
        fputs(RANNU_TEXT, stderr);
        fputs("\n", stderr);
        return 0; /* FALSE */
    }

    for(;;) {
        p = fgets(c, BUFFER_SIZE, text);
        if(p == NULL) {
            break;
        }

        reduce_non_number_sequences(c, to, TO_BUFFER_SIZE, NUMBER_COUNT);
        fputs(to, file);
        fputs("\n", file);
    }

    fclose(file); /* RANNU_TEXT */
    fclose(text);
    return TRUE;
}

void reduce_non_number_sequences(char *p, char *to, int to_array_size, int number_count) {
/*
05 06 14 /17 25 /29 31 38 // -123 
05 06 14 17 25 29 31 38 123
number_count = 9
*/
    char *from;
    const int GAP_C = 0x20;
    const int GAP_SIZE = 1;
    int cycle, i, n, u;

    memset(to, 0, to_array_size);
    for(i = 0; i < number_count; ++i) {
        n = strspn(p, "0123456789");
        from = p;
        p += n;

        u = strcspn(p, "0123456789");
        p += u;

        memcpy(to, from, n);
        *(to + n) = GAP_C;
        cycle = n + GAP_SIZE;
        to += cycle;
    }

}
