/*
ovee Version 1.02
To remove files according to remove_e.txt
Copyright 2014 Sogaya

Watcom

*/

#define BUFFER_SIZE 256
#define REMOVE_E_TEXT "remove_e.txt"
#define TRUE 1
#define USAGE "ovee Version 1.02\n\novee\novee -V\novee -w-\n"
#define WHO_TEXT "who.txt"
#include <stdio.h>
#include <string.h>

typedef int BOOL;

void chopped(char *s) {
	char *p;

/* Removing the new-line character */
	p = strrchr(s, '\n');
	if(p != NULL) {
		*p = '\0';
	}
}

int main(int argc, char *argv[]) {
	BOOL do_not_remove_who_text = 0; /* FALSE */
	char *p;
	char c[BUFFER_SIZE];
	char file_name[] = REMOVE_E_TEXT;
	FILE *file;

	switch(argc) {
	case 1:
		break;
	case 2:
		if(! strcmp(argv[1], "-V") ) {
			fprintf(stderr, USAGE);
			return 1;
		} else if(! strcmp(argv[1], "-w-") ) {
			do_not_remove_who_text = TRUE;
			break;
		}

		break;
	default:
		fprintf(stderr, USAGE);
		return 1;
	}

	file = fopen(file_name, "rt");
	if(file == NULL) {
		fprintf(stderr, "%s\n", file_name);
		return 1;
	}

	for(;;) {
		p = fgets(c, BUFFER_SIZE, file);
		if(p == NULL) {
			break;
		}

		chopped(c);
		if(do_not_remove_who_text) {
			if(! strcmp(c, WHO_TEXT) ) {
				continue;
			}
		}

		remove(c);
	}

	fclose(file);
	return 0;
}
