package info.lotosummary.software;
import java.io.*;

public class EditCount {
    static final int ERROR_CODE = 1;
    static final int MANAGE_TEXT_LINE_COUNT = 10;
    static final int NOT_CONVERTED = -1;
    static final int BALLS = 4;
    static final String DRAFO_CSV = "drafo.csv";
    static final String ERROR_TEXT = "error.txt";
    static final String ZERO = "0";
    static final String MANAGE_TEXT = "manage.txt";

    boolean countBonus, csv, firstLine, noSplitting, preedit, quit, serialNumber, threeLinesUnited, whoText;
    Combo co;
    Drafo dr;
    ExcludeText et;
    FormDateLine fd;
    int balls, itemCount, NEW_LINE_LENGTH, rowCount;
    NewLines nl;
    String error, fileName, FULL_PATH_NAME, list_of_items, NEW_LINE, saveName, timeNameText;
    String[] m = {
             "", // m[0], FULL_PATH_NAME includes MANAGE_TEXT.
      "who.txt", // m[1], fileName
  "exclude.txt", // m[2], list_of_items
            "4", // m[3], balls
            "1", // m[4], firstLine
            "0", // m[5], noSplitting
            "1", // m[6], preedit
         "5000", // m[7], rowCount
            "1", // m[8], serialNumber
            "0", // m[9], whoText
            "0"  // m[10], threeLinesUnited
        };

    TableCsv tc;
    ZokoBonus zb;
    ZokoMask zm;

    private boolean createErrorText(String messages) {
        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(ERROR_TEXT) );
            file.write(messages); file.newLine();
            file.close();
            return true;
        } catch(Exception e39) {
            error = "Exception e39: " + ERROR_TEXT;
            return false;
        }

    }

    private boolean readManageText() {
        m[0] = FULL_PATH_NAME;

        try {
            BufferedReader buffered = new BufferedReader( new FileReader(FULL_PATH_NAME) );
            for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1) {
                m[line] = buffered.readLine();
                if(m[line] == null) {
                    break;
                }

            }

            buffered.close();
            stringArrayToValues();
            return true;
        } catch(IOException e1) {
            error = "IOException e1: " + FULL_PATH_NAME;
            createErrorText(error);
            return false;
        }

    }

    private int integerFromString(String s) {
        int result;

        try {
            result = Integer.parseInt(s);
            return result;
        } catch(NumberFormatException e33) {
            error = "NumberFormatException e33";
            return NOT_CONVERTED;
        }

    }

    private void stringArrayToValues() {
        fileName = m[1];
        list_of_items = m[2];
        balls = integerFromString(m[3]);
        firstLine = ( ZERO.equals(m[4]) ) ? false : true;
        noSplitting = ( ZERO.equals(m[5]) ) ? false : true;
        preedit = ( ZERO.equals(m[6]) ) ? false : true;
        rowCount = integerFromString(m[7]);
        serialNumber = ( ZERO.equals(m[8]) ) ? false : true;
        whoText = ( ZERO.equals(m[9]) ) ? false : true;
        threeLinesUnited = ( ZERO.equals(m[10]) ) ? false : true;
    }

    public boolean editCount() {
        boolean result;

        if(preedit) {
            if(threeLinesUnited) {
                fd = new FormDateLine(firstLine, serialNumber, whoText);
                if( fd.altering(fileName) ) {
                    fileName = fd.altered();
                } else {
                    createErrorText( fd.inquiry() );
                    return false;
                }

            }

            et = new ExcludeText(list_of_items, firstLine, serialNumber, whoText);
            if( et.altering(fileName) ) {
                fileName = et.altered();
            } else {
                createErrorText( et.inquiry() );
                return false;
            }

            dr = new Drafo(DRAFO_CSV, firstLine, serialNumber, whoText);
            if( dr.altering(fileName) ) {
                fileName = dr.altered();
            } else {
                createErrorText( dr.inquiry() );
                return false;
            }

            co = new Combo(firstLine, serialNumber, whoText);
            if( co.altering(fileName) ) {
                fileName = co.altered();
            } else {
                createErrorText( co.inquiry() );
                return false;
            }

            nl = new NewLines(firstLine, serialNumber, whoText);
            if( nl.altering(fileName) ) {
                fileName = nl.altered();
            } else {
                createErrorText( nl.inquiry() );
                return false;
            }

        }

        if(csv) {
            tc = new TableCsv(rowCount, serialNumber, whoText);
            if( tc.run(fileName) ) {
                result = true;
            } else {
                createErrorText( tc.inquiry() );
                return false;
            }

        } else {
            if(countBonus) {
                zb = new ZokoBonus(balls, noSplitting, serialNumber, whoText);
                if( zb.run(fileName) ) {
                    result = true;
                } else {
                    createErrorText( zb.inquiry() );
                    return false;
                }

            } else {
                zm = new ZokoMask(balls, noSplitting, serialNumber, whoText);
                if( zm.run(fileName) ) {
                    result = true;
                } else {
                    createErrorText( zm.inquiry() );
                    return false;
                }

            }

        }

        return result;
    }

    public boolean preediting() {
        if(threeLinesUnited) {
            fd = new FormDateLine(firstLine, serialNumber, whoText);
            if( fd.altering(fileName) ) {
                fileName = fd.altered();
                System.out.println( "-3: " + fileName );
            } else {
                createErrorText( fd.inquiry() );
                return false;
            }

        }

        et = new ExcludeText(list_of_items, firstLine, serialNumber, whoText);
        if( et.altering(fileName) ) {
            fileName = et.altered();
            System.out.println( "-e: " + fileName );
        } else {
            createErrorText( et.inquiry() );
            return false;
        }

        dr = new Drafo(DRAFO_CSV, firstLine, serialNumber, whoText);
        if( dr.altering(fileName) ) {
            fileName = dr.altered();
            System.out.println( "-z: " + fileName );
        } else {
            createErrorText( dr.inquiry() );
            return false;
        }

        co = new Combo(firstLine, serialNumber, whoText);
        if( co.altering(fileName) ) {
            fileName = co.altered();
            System.out.println( "-c: " + fileName );
        } else {
            createErrorText( co.inquiry() );
            return false;
        }

        nl = new NewLines(firstLine, serialNumber, whoText);
        if( nl.altering(fileName) ) {
            fileName = nl.altered();
            System.out.println( "-n: " + fileName );
        } else {
            createErrorText( nl.inquiry() );
            return false;
        }

        return true;
    }

    public boolean setting(String f, String fi, String l, int b, boolean c, boolean cs, boolean fir, boolean n, boolean p, boolean q, boolean s, boolean t, boolean w) {
        FULL_PATH_NAME = f;
        boolean r = readManageText();

        fileName = fi;
        list_of_items = l;
        balls = b;
        countBonus = c;
        csv = cs;
        firstLine = fir;
        noSplitting = n;
        preedit = p;
        quit = q;
        serialNumber = s;
        threeLinesUnited = t;
        whoText = w;

        if(balls < 1 || 7 < balls) {
            balls = BALLS;
        }

        return r;
    }

    public EditCount() {
    }

}
