package info.lotosummary.software;
import java.io.*;

public class FormDateLine {
    static final int RING_COUNT = 3;
    static final String EMPTY = "";
    static final String GAP = " ";
    static final String ID_COLON = " ID:";
    static final String TEXT_FILE = ".txt";
    static final String WHO = "who";
    static final String WHO_TEXT = "who.txt";

    boolean firstLine, serialNumber, whoText;
    int NEW_LINE_LENGTH;
    Queue ring;
    String error, NEW_LINE, saveName, whose;
    StringBuffer buffer, combos;
    String[] new_line;
    String[] separator;

    private boolean openSaveClose(String fileName) {
        String s = buffer.toString();
        int size = s.length();
        String c;

// Trimming
        for(int i = 0; i < size; i += NEW_LINE_LENGTH) {
            c = s.substring(i, i + NEW_LINE_LENGTH );
            if( NEW_LINE.equals(c) ) {
                continue;
            } else {
                s = s.substring(i);
                break;
            }

        }

// Writing
        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(fileName) );
            file.write(s); file.newLine();
            file.close();
            return true;
        } catch (IOException e28) {
            error = "IOException e28: " + fileName;
            return false;
        }

    }

    private int produceRingBuffer(int size) {
        String BLANK = " ";
        ring.clear();
        for(int i = 0; i < size; i += 1) {
            ring.push_back(BLANK);
        }

        return ring.queue_size();
    }

    private void add(String s) {
        combos.append(s);
        combos.append(NEW_LINE);
    }

    private void blankRingBuffer() {
        String BLANK = " ";
        ring.pop_front();
        ring.push_back(BLANK);
        ring.pop_front();
        ring.push_back(BLANK);
        ring.pop_front();
        ring.push_back(BLANK);
    }

    private void clear(String s) {
        combos = new StringBuffer();
        whose = s;
    }

    private void listing() {
        String c = combos.toString();
        buffer.append(whose);
        buffer.append(NEW_LINE);
        buffer.append(c);
    }

    public boolean altering(String fileName) {
        Characterizable lineType;
        int q, r;
        String s = EMPTY;
        StringBuffer os;

        if(whoText) {
            saveName = WHO_TEXT;
        } else {
            TimeName wt = new TimeName(WHO, TEXT_FILE);
            saveName = wt.temporaryName(serialNumber);
        }

// ring buffer
        produceRingBuffer(RING_COUNT);

        try {
            BufferedReader buffered = new BufferedReader( new FileReader(fileName) );
// Line-1
            s = buffered.readLine();
            if(s == null) {
                error = "e52(Line-1): s == null";
                return false;
            }

            if(firstLine) {
                add(s);
                listing();
                clear(EMPTY);
            }

            for(;;) {
                s = buffered.readLine();
                if(s == null) {
                    break;
                }

                ring.pop_front();
                ring.push_back(s);

                q = s.indexOf(ID_COLON);
                if(q >= 0) {
                    s = ring.chain(separator);
                    lineType = new DateFollowed(s);
                    r = lineType.dateLine();
                    if(r > 0) {
                        listing();

                        s = lineType.interposed();
                        clear(s);
                        blankRingBuffer();
                        continue;
                    } else {
                        s = ring.front();
                    }

                } else {
                    s = ring.front();
                }

                add(s);
            }

            buffered.close();

            ring.pop_front();
            s = ring.chain(new_line);
            add(s);

            listing();
            openSaveClose(saveName);

            return true;
        } catch(IOException e13) {
            error = "IOException e13: " + fileName;
            return false;
        }

    }

    public FormDateLine(boolean f, boolean s, boolean w) {
        firstLine = f;
        serialNumber = s;
        whoText = w;
        NEW_LINE = System.getProperty("line.separator");
        NEW_LINE_LENGTH = NEW_LINE.length();

        new_line = new String[RING_COUNT];
        for(int i = 0; i < RING_COUNT; ++i) {
            new_line[i] = NEW_LINE;
        }

        separator = new String[RING_COUNT];
        separator[0] = EMPTY;
        for(int i = 1; i < RING_COUNT; ++i) {
            separator[i] = GAP;
        }

        buffer = new StringBuffer();
        combos = new StringBuffer();
        ring = new Queue();
        whose = EMPTY;
    }

    public String altered() {
        return saveName;
    }

    public String inquiry() {
        return error;
    }

}
