package info.lotosummary.software;

import java.io.*;
import java.util.*;

public class Mark {
    static final boolean SERIAL_NUMBER = true;
    static final int ADD_THE_DRAW_TO_LINE_1_OF_WHO_TXT = 3;
    static final int BALL_SET_COUNT = 10;
    static final int BALLS_BONUS = 9; // LOTO_7 + 2
    static final int BEIGE = 2;
    static final int BLUE = 4;
    static final int DRAW_ARRAY_SIZE = 12;
    static final int FIELD_COUNT = 12;
    static final int GAP_SIZE = 1;
    static final int GREEN = 3;
    static final int LABEL_COUNT = 18;
    static final int LOTO_6_COUNT = 43;
    static final int LOTO_7 = 7;
    static final int LOTO6 = 6;
    static final int LOTO7 = 7;
    static final int MINILOTO = 5;
    static final int NAVY = 5;
    static final int NOT_CONVERTED = -1;
    static final int PLACE_COUNT = 11; // BALLS_BONUS < PLACE_COUNT < FIELD_COUNT
    static final int PURPLE = 6;
    static final int RED = 0;
    static final int TOO_FEW_GAPS = 4;
    static final int UNASSIGNED = -1;
    static final int YELLOW = 1;
    static final String BLACK_CIRCLE = ""; // Shift_JIS
    static final String CLOSE_BRACKET = ") ";
    static final String EMPTY = "";
    static final String GAP = " ";
    static final String HYPHEN = "-";
    static final String KANJI_BEIGE = "x";
    static final String KANJI_BLUE = "";
    static final String KANJI_DAI = "";
    static final String KANJI_GREEN = "";
    static final String KANJI_KAI = "";
    static final String KANJI_NAVY = "";
    static final String KANJI_PURPLE = "";
    static final String KANJI_RED = "";
    static final String KANJI_SET = "Zbg";
    static final String KANJI_YELLOW = "";
    static final String MINUS = "-";
    static final String MINUS_0TO9_ATOJ = "-0123456789ABCDEFGHIJ";
    static final String PARENTHESIS = "(";
    static final String SEE = "see";
    static final String TEXT_FILE = ".txt";
    static final String WHITE_CIRCLE = "";

    BallXY[] b;
    boolean second;
    boolean[] check = {false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false};
    int beige_number, blue_number, green_number, navy_number, points, purple_number, red_number, yellow_number, z_bonus_number, z_missing_number;
    int[] place = {0, 32, 64, 96, 128, 160, 192, 224, 256, 288, 320};
    MissingBonus[][] mb;
    String drawNumber, error, firstLine;
    String[] ball = {"", "01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", "32", "33", "34", "35", "36", "37", "38", "39", "40", "41", "42", "43"};
    String[] ballSet = {"-A", "-B", "-C", "-D", "-E", "-F", "-G", "-H", "-I", "-J"};
    String[] label = {"", "", "", "", "", "", "", "", "", "", ""};
    String[] readLabels = {"", "", "", "", "", "", "@ 01112131", "", "", "", "", "", "", "", "", "", "", "@ 102030"}; // Shift_JIS
    StringBuffer buffer;

    private boolean createSeeText() {
        String saveName;

        for(int y = 1; y <= 10; ++y) {
            readLabels[ y + 6 ] = label[y];
        }

        TimeName wt = new TimeName(SEE, TEXT_FILE);
        saveName = wt.temporaryName(SERIAL_NUMBER);
        System.out.println(saveName);

        try {
            BufferedWriter text = new BufferedWriter( new FileWriter(saveName) );
            for(int i = 0; i < LABEL_COUNT; ++i) {
                text.write(readLabels[i]);
                text.newLine();
            }

            text.close();
            return true;
        } catch(Exception e34) {
            error = "Exception e34: " + saveName;
            return false;
        }

    }

    private boolean setting() {
        int loto = checkLine1(firstLine);
        switch(loto) {
        case ADD_THE_DRAW_TO_LINE_1_OF_WHO_TXT:
            error = "e63: ADD THE DRAW TO LINE-1 OF WHO.TXT";
            return false;
        case LOTO6:
            error = "e64: LOTO6";
            return false;
        case MINILOTO:
            error = "e65: MINILOTO";
            return false;
        case TOO_FEW_GAPS:
            error = "e66: TOO FEW GAPS";
            return false;
        default:
            break;
        }

        int Q = BALLS_BONUS * 3;
        String ballsBonus = firstLine.substring(0, Q);
        readLabels[0] = ballsBonus;
        drawNumber = kanjiColors(firstLine);
        announcement(drawNumber, firstLine);
        arrayBallXY(); // label[]

        if(second) {
            MissingBonus mb = new MissingBonus(z_bonus_number, z_missing_number);
            System.out.println( mb.hyphenated() );
            missingBonusHandler(mb);
        } else {
            createSeeText();
        }

        decideWhichSet();
        return true;
    }

    private int checkLine1(String line) {
/*
012345678901234567890123456789012
31 18 15 06 14 25 
31 18 15 06 14 25 -A -776
35 29 12 16 13 28 05 
35 29 12 16 13 28 05 -B -548
04 26 32 29 05 25 15 27 11 
04 26 32 29 05 25 15 27 11 -D -92
*/
        int q;
        String s = line;
        for(int i = 0; i < 6; ++i) {
            q = s.indexOf(GAP);
            if(q >= 0) {
                q += GAP_SIZE;
                s = s.substring(q);
            } else {
                return TOO_FEW_GAPS;
            }

        }

        int lineLength = line.length();
        if(lineLength == 18) {
            return MINILOTO;
        }

        if( MINUS.equals( line.substring(18, 19) ) ) {
            return MINILOTO;
        }

        if(lineLength == 21) {
            return LOTO6;
        }

        if( MINUS.equals( line.substring(21, 22) ) ) {
            return LOTO6;
        }

        if(lineLength == 27) {
            return LOTO7;
        }

        if( MINUS.equals( line.substring(27, 28) ) ) {
            return LOTO7;
        }

        return ADD_THE_DRAW_TO_LINE_1_OF_WHO_TXT;
    }

    private int sequenceOfNumbers(String line, int p) {
        int count = 0;
        int q;
        int size = line.length();
        String c;
        for(int i = p; i < size; ++i) {
            c = line.substring(i, i + 1 );
            q = MINUS_0TO9_ATOJ.indexOf(c);
            if(q >= 0) {
                count += 1;
                continue;
            } else {
                break;
            }

        }

        return count;
    }

    private int sequence_of_non_numbers(String line, int p) {
        int count = 0;
        int q;
        int size = line.length();
        String c;
        for(int i = p; i < size; ++i) {
            c = line.substring(i, i + 1 );
            q = MINUS_0TO9_ATOJ.indexOf(c);
            if(q >= 0) {
                break;
            } else {
                count += 1;
                continue;
            }

        }

        return count;
    }

    private int integerFromString(String s) {
        int result;

        try {
            result = Integer.parseInt(s);
            return result;
        } catch(NumberFormatException e3) {
            error = "NumberFormatException e3";
            return NOT_CONVERTED;
        }

    }

    private String itemCaption(String s, String bonus, int which, int place) {
        int Q = place * 3;
        String tail = s.substring(Q);
        String missing = tail.substring(0, 2);
        String i = missing + HYPHEN + bonus;

        mb[which][place] = new MissingBonus(bonus, missing);
        return i;
    }

    private String kanjiColors(String line) {
        BallColorSet bcs = new BallColorSet();
        int ball_set = 0;
        int c;
        String[] field = dividing(line);
        String FIELD_9 = field[9];
        String FIELD_10 = field[10];
        StringBuffer os = new StringBuffer();

        for(int i = 0; i < BALL_SET_COUNT; ++i) {
            if( FIELD_9.equals(ballSet[i]) ) {
                ball_set = i;
            }

        }

        String ascii_set = FIELD_9.substring(1);
        String A_J_KANJI_SET = ascii_set + KANJI_SET;
        readLabels[2] = A_J_KANJI_SET;

        String draw_number = FIELD_10.substring(1);

        for(int i = 0; i < BALLS_BONUS; ++i) {
            c = bcs.ballColor(field[i], ball_set);
            switch(c) {
            case RED:
                os.append(KANJI_RED);
                os.append(GAP);
                break;
            case YELLOW:
                os.append(KANJI_YELLOW);
                os.append(GAP);
                break;
            case BEIGE:
                os.append(KANJI_BEIGE);
                os.append(GAP);
                break;
            case GREEN:
                os.append(KANJI_GREEN);
                os.append(GAP);
                break;
            case BLUE:
                os.append(KANJI_BLUE);
                os.append(GAP);
                break;
            case NAVY:
                os.append(KANJI_NAVY);
                os.append(GAP);
                break;
            case PURPLE:
                os.append(KANJI_PURPLE);
                os.append(GAP);
                break;
            default:
                break;
            }

        }

        String KANJI_COLORS = os.toString();
        readLabels[1] = KANJI_COLORS;

        return draw_number;
    }

    private String smallerBigger(String pair) {
        int q;
        q = pair.indexOf(GAP);
        String first = pair.substring(0, q);
        q += GAP_SIZE;
        String second = pair.substring(q);

        q = second.indexOf(GAP);
        if(q >= 0) {
            second = second.substring(0, q);
        }

        int n1 = integerFromString(first);
        int n2 = integerFromString(second);

        StringBuffer os = new StringBuffer();
        if(n1 < n2) {
            os.append(first);
            os.append(GAP);
            os.append(second);
        } else {
            os.append(second);
            os.append(GAP);
            os.append(first);
        }

        String s = os.toString();
        return s;
    }

    private String[] dividing(String line) {
        String[] a = {"", "", "", "", "", "", "", "", "", "", "", ""};
        int from = 0;
        int n, u;
        int p = 0;

        for(int i = 0; i < DRAW_ARRAY_SIZE; ++i) {
            n = sequenceOfNumbers(line, p);
            from = p;
            p += n;

            u = sequence_of_non_numbers(line, p);
            p += u;

            a[i] = line.substring(from, from + n );
        }

        return a;
    }

    private void add(int b, int c) {
        BallColorSet bcs = new BallColorSet();
        String s = bcs.ballSetList(b, c); // list of ball sets
        buffer.append(s);
    }

    private void announcement(String draw_number, String s) {
        int q;
        int Q = LOTO_7 * 3;
        String head = s.substring(0, Q);
        String tail = s.substring(Q);
        String smaller_bigger = smallerBigger(tail);

        for(int i = 1; i <= LOTO_6_COUNT; ++i) {
            q = head.indexOf(ball[i]);
            if(q >= 0) {
                check[i] = true;
            } else {
                check[i] = false;
            }

        }

        StringBuffer os = new StringBuffer();
        os.append(KANJI_DAI);
        os.append(draw_number);
        os.append(KANJI_KAI);
        os.append(GAP);

        for(int i = 1; i <= LOTO_6_COUNT; ++i) {
            if(check[i]) {
                os.append(ball[i]);
                os.append(GAP);
            }

        }

        os.append(PARENTHESIS);
        os.append(smaller_bigger);
        os.append(CLOSE_BRACKET);

        String sorted = os.toString();
        readLabels[4] = sorted;
    }

    private void arrayBallXY() {
        boolean found;
        int width = 4;
        String s;
        String[] head = {"", "01", "02", "03", "04", "05", "06", "07", "08", "09", "10"};
        String[] tail = {"", "31", "32", "33", "34", "35", "36", "37"};
        StringBuffer os;

        b[0] = new BallXY(ball[0], 0, 0, check[0]);
        b[1] = new BallXY(ball[1], 1, 1, check[1]);
        b[2] = new BallXY(ball[2], 1, 2, check[2]);
        b[3] = new BallXY(ball[3], 1, 3, check[3]);
        b[4] = new BallXY(ball[4], 1, 4, check[4]);
        b[5] = new BallXY(ball[5], 1, 5, check[5]);
        b[6] = new BallXY(ball[6], 1, 6, check[6]);
        b[7] = new BallXY(ball[7], 1, 7, check[7]);
        b[8] = new BallXY(ball[8], 1, 8, check[8]);
        b[9] = new BallXY(ball[9], 1, 9, check[9]);
        b[10] = new BallXY(ball[10], 1, 10, check[10]);
        b[11] = new BallXY(ball[11], 2, 1, check[11]);
        b[12] = new BallXY(ball[12], 2, 2, check[12]);
        b[13] = new BallXY(ball[13], 2, 3, check[13]);
        b[14] = new BallXY(ball[14], 2, 4, check[14]);
        b[15] = new BallXY(ball[15], 2, 5, check[15]);
        b[16] = new BallXY(ball[16], 2, 6, check[16]);
        b[17] = new BallXY(ball[17], 2, 7, check[17]);
        b[18] = new BallXY(ball[18], 2, 8, check[18]);
        b[19] = new BallXY(ball[19], 2, 9, check[19]);
        b[20] = new BallXY(ball[20], 2, 10, check[20]);
        b[21] = new BallXY(ball[21], 3, 1, check[21]);
        b[22] = new BallXY(ball[22], 3, 2, check[22]);
        b[23] = new BallXY(ball[23], 3, 3, check[23]);
        b[24] = new BallXY(ball[24], 3, 4, check[24]);
        b[25] = new BallXY(ball[25], 3, 5, check[25]);
        b[26] = new BallXY(ball[26], 3, 6, check[26]);
        b[27] = new BallXY(ball[27], 3, 7, check[27]);
        b[28] = new BallXY(ball[28], 3, 8, check[28]);
        b[29] = new BallXY(ball[29], 3, 9, check[29]);
        b[30] = new BallXY(ball[30], 3, 10, check[30]);
        b[31] = new BallXY(ball[31], 4, 1, check[31]);
        b[32] = new BallXY(ball[32], 4, 2, check[32]);
        b[33] = new BallXY(ball[33], 4, 3, check[33]);
        b[34] = new BallXY(ball[34], 4, 4, check[34]);
        b[35] = new BallXY(ball[35], 4, 5, check[35]);
        b[36] = new BallXY(ball[36], 4, 6, check[36]);
        b[37] = new BallXY(ball[37], 4, 7, check[37]);
        b[38] = new BallXY(ball[38], 4, 8, check[38]);
        b[39] = new BallXY(ball[39], 4, 9, check[39]);
        b[40] = new BallXY(ball[40], 4, 10, check[40]);
        b[41] = new BallXY(ball[41], 5, 1, check[41]);
        b[42] = new BallXY(ball[42], 5, 2, check[42]);
        b[43] = new BallXY(ball[43], 5, 3, check[43]);

        for(int y = 1; y <= 10; ++y) {
            os = new StringBuffer();

            if(y > 7) { // 38, 39, 40
                width = 3;
            }

            for(int x = 1; x <= width; ++x) {
                found = false;

// Checking if a black circle appears at (x, y)
                for(int i = 1; i <= LOTO_6_COUNT; ++i) {
                    if( x == b[i].ballX() ) {
                        if( y == b[i].ballY() ) {
                            if( b[i].black() ) {
                                found = true;
                            }

                        }

                    }

                }

                if(found) {
                    os.append(BLACK_CIRCLE);
                } else {
                    os.append(WHITE_CIRCLE);
                }

            }

            s = os.toString();
            if(width == 3) {
                label[y] = head[y] + s;
            } else {
                label[y] = head[y] + s + tail[y];
            }

        }

    }

    private void decideWhichSet() {
        if(beige_number != UNASSIGNED) {
            add(beige_number, BEIGE);
        }

        if(blue_number != UNASSIGNED) {
            add(blue_number, BLUE);
        }

        if(green_number != UNASSIGNED) {
            add(green_number, GREEN);
        }

        if(navy_number != UNASSIGNED) {
            add(navy_number, NAVY);
        }

        if(purple_number != UNASSIGNED) {
            add(purple_number, PURPLE);
        }

        if(red_number != UNASSIGNED) {
            add(red_number, RED);
        }

        if(yellow_number != UNASSIGNED) {
            add(yellow_number, YELLOW);
        }

        String list_of_ball_sets = buffer.toString();
        if( list_of_ball_sets.length() > 0 ) {
            System.out.println(list_of_ball_sets);
        }

    }

    private void missingBonusHandler(MissingBonus p) {
// Replacing a missing ball with a bonus ball
        int B = p.bonusBallNumber();
        boolean OLD_CHECK = check[B];
        check[B] = true;

        int M = p.missingBallNumber();
        boolean OLD_MISSINNG = check[M];
        check[M] = false;
        arrayBallXY();
        createSeeText();

// Restoring
        check[B] = OLD_CHECK;
        check[M] = OLD_MISSINNG;
    }

    public Mark(ManageMemo mm) {
        b = new BallXY[ LOTO_6_COUNT + 1 ];
        buffer = new StringBuffer();
        mb = new MissingBonus[LOTO_7][LOTO_7];

        beige_number = mm.ballNumber(BEIGE);
        blue_number = mm.ballNumber(BLUE);
        firstLine = mm.firstLine();
        green_number = mm.ballNumber(GREEN);
        navy_number = mm.ballNumber(NAVY);
        purple_number = mm.ballNumber(PURPLE);
        red_number = mm.ballNumber(RED);
        yellow_number = mm.ballNumber(YELLOW);
        z_bonus_number = mm.bonus();
        z_missing_number = mm.missing();

        if(z_bonus_number == UNASSIGNED) {
            second = false;
        } else {
            if(z_missing_number == UNASSIGNED) {
                second = false;
            } else {
                second = true;
            }

        }

        if( setting() ) {
            ;
        } else {
            decideWhichSet();
        }

    }

}
