package info.lotosummary.software;

public class Numbered {
    static final int NOT_CONVERTED = -1;
    static final int NOT_FOUND = -1;
    static final int TRIMMING = 1;
    static final String N_0TO9 = "0123456789";
    boolean trimmed;
    int k, length, non_number_length, span, trimmed_sequence_length;
    String error, f, ft, pt, s, st;

    private int leadingNumbers(String full) {
        int fullLength = full.length();
        int k, q;
        String c;
        for(k = 0; k < fullLength; k += 1 ) {
            c = full.substring(k, k + 1 );
            q = N_0TO9.indexOf(c);
            if(q >= 0) {
                continue;
            } else {
                break;
            }

        }

        return k;
    }

    private int integerFromString(String s) {
        int result;

        try {
            result = Integer.parseInt(s);
            return result;
        } catch(NumberFormatException e7) {
            error = "NumberFormatException e7";
            return NOT_CONVERTED;
        }

    }

    private int trailingNumbers(String full) {
        int fullLength = full.length();
        int k, q, n;
        String c;
        for(n = 0; n < fullLength; n += 1 ) {
            k = fullLength - 1 - n;
            c = full.substring(k, k + 1 );
            q = N_0TO9.indexOf(c);
            if(q >= 0) {
                continue;
            } else {
                break;
            }

        }

        return n;
    }

    public boolean trimmed_sequence() {
        int size, u;
        String q;
/*
a: -i1-37
first part of a: -i1-
second part of a: 37
trimmed sequence: -i1
first part of trimmed sequence: -i
second part of trimmed sequence: 1
*/

// Trimming the first part of a
        trimmed_sequence_length = f.length() - TRIMMING;
        pt = f.substring(0, trimmed_sequence_length);
        trimmed = true;

        u = trailingNumbers(pt);
        if(u == 0) {
            trimmed = false;
            return trimmed;
        }

        span = u;
        non_number_length = trimmed_sequence_length - span;

// Copying the second part of trimmed sequence
        st = pt.substring(non_number_length);

// Copying the first part of trimmed sequence
        ft = pt.substring(0, non_number_length);
        return true;
    }

    public Numbered(String a) {
        int size;
        String q;

        trimmed = false;
        length = a.length();

        span = trailingNumbers(a);
        non_number_length = length - span;

// Copying the second part of a
        s = a.substring(non_number_length);

// Copying the first part of a
        f = a.substring(0, non_number_length);
    }

    public String parameter() {
        if(trimmed) {
            return ft;
        } else {
            return f;
        }

    }

    public int number() {
        return integerFromString(s);
    }

    public int subnumber() {
        int k = NOT_FOUND;

        if(trimmed) {
            k = integerFromString(st);
        }

        return k;
    }

};

