package info.lotosummary.software;
import java.io.*;
import java.util.Arrays;

public class TableCsv {
    static final boolean SORT_IN_REVERSE_ORDER = true;
    static final int ALL_QP_SIZE = 6;
    static final int DRAW_ARRAY_SIZE = 12;
    static final int SEPARATOR_SIZE = 1;
    static final int STANDARD_LINE_LENGTH = 20; // "07 14 20 24 28 32 37"
    static final String ALL_QP = "ALL QP";
    static final String ANCHOR = ">>";
    static final String COMMA = ",";
    static final String CSV_FILE = ".csv";
    static final String EMPTY = "";
    static final String GAP = " ";
    static final String GAP_SLASH = " /";
    static final String GAP_SLASH_SLASH = " //";
    static final String ID_COLON = " ID:";
    static final String N_0TO9 = "0123456789";
    static final String QP = "QP";
    static final String SEPARATOR = "`";
    static final String SPACE = "@";
	static final String TILDE = "~";
    static final String WHO = "who";
    static final String WHO_TEXT = "who.txt";

    boolean scope, serialNumber, whoText;
    int count, NEW_LINE_LENGTH, rowCount, split, total;
    String[] a = {"", "", "", "", "", "", "", "", "", "", "", ""};
    String[] csv;
    String[] draw = {"", "", "", "", "", "", "", "", "", "", "", ""};
    String[] table;
    String error, NEW_LINE, timeNameText, whose;
    StringBuffer buffer;
    StringBuffer combos;

    private boolean allQP(String s) {
        if(scope) {
            return true;
        }

        int q = s.indexOf(ALL_QP);
        if(q >= 0) {
            scope = true;
        }

        return scope;
    }

    private boolean openSaveClose(String fileName) {
        String s = buffer.toString();
        int size = s.length();
        String c;

// Trimming
        for(int i = 0; i < size; i += NEW_LINE_LENGTH) {
            c = s.substring(i, i + NEW_LINE_LENGTH );
            if( NEW_LINE.equals(c) ) {
                continue;
            } else {
                s = s.substring(i);
                break;
            }

        }

// Writing
        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(fileName) );
            file.write(s);
            file.close();
            return true;
        } catch (IOException e4) {
            error = "IOException e4: " + fileName;
            return false;
        }

    }

    private boolean sorting(String fileName, boolean reverse) {
        String s;

// Reading and sorting
        try {
            BufferedReader buffered = new BufferedReader( new FileReader(fileName) );
            int bound = 0;
            for(int i = 0; i < rowCount; ++i) {
                s = buffered.readLine();
                if(s == null) {
                    bound = i;
                    break;
                }

                csv[i] = s;
            }

            buffered.close();
            Arrays.sort(csv);

            int k = 0;
            StringBuffer os = new StringBuffer();
            table = new String[bound];
            if(reverse) {
                for(int i = bound - 1; i >= 0; --i) {
                    os.append(csv[i]);
                    os.append(NEW_LINE);
                    table[k++] = csv[i];
                }

            } else {
                for(int i = 0; i < bound; ++i) {
                    os.append(csv[i]);
                    os.append(NEW_LINE);
                    table[k++] = csv[i];
                }

            }

            s = os.toString();
        } catch (IOException e2) {
            error = "IOException e2: " + fileName;
            return false;
        }

        if(whoText) {
            timeNameText = WHO_TEXT;
        } else {
            TimeName wt = new TimeName(WHO, CSV_FILE);
            timeNameText = wt.temporaryName(serialNumber);
            System.out.println(timeNameText);
        }

// Writing
        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(timeNameText) );
            file.write(s);
            file.close();
            return true;
        } catch (IOException e5) {
            error = "IOException e5: " + fileName;
            return false;
        }

    }

    private int countBalls(String s) {
        int count = 0;
        int q;

        q = s.indexOf(draw[1]);
        if(q >= 0) {
            count += 1;
        }

        q = s.indexOf(draw[2]);
        if(q >= 0) {
            count += 1;
        }

        q = s.indexOf(draw[3]);
        if(q >= 0) {
            count += 1;
        }

        q = s.indexOf(draw[4]);
        if(q >= 0) {
            count += 1;
        }

        q = s.indexOf(draw[5]);
        if(q >= 0) {
            count += 1;
        }

        q = s.indexOf(draw[6]);
        if(q >= 0) {
            count += 1;
        }

        q = s.indexOf(draw[7]);
        if(q >= 0) {
            count += 1;
        }

        return count;
    }

    private int sequenceOfNumbers(String line, int p) {
        int count = 0;
        int q;
        int size = line.length();
        String c;
        for(int i = p; i < size; ++i) {
            c = line.substring(i, i + 1 );
            q = N_0TO9.indexOf(c);
            if(q >= 0) {
                count += 1;
                continue;
            } else {
                break;
            }

        }

        return count;
    }

    private int sequence_of_non_numbers(String line, int p) {
        int count = 0;
        int q;
        int size = line.length();
        String c;
        for(int i = p; i < size; ++i) {
            c = line.substring(i, i + 1 );
            q = N_0TO9.indexOf(c);
            if(q >= 0) {
                break;
            } else {
                count += 1;
                continue;
            }

        }

        return count;
    }

    private String assembling() {
        StringBuffer os = new StringBuffer();

        for(int i = 1; i < DRAW_ARRAY_SIZE; ++i) {
            if( a[i].length() > 0 ) {
                os.append(a[i]);
                os.append(GAP);
            }

        }

        String s = os.toString();
        return s;
    }

    private String[] dividing(String line) {
        String[] a = {"", "", "", "", "", "", "", "", "", "", "", ""};
        int from = 0;
        int n, u;
        int p = 0;

        for(int i = 1; i < DRAW_ARRAY_SIZE; ++i) {
            n = sequenceOfNumbers(line, p);
            from = p;
            p += n;

            u = sequence_of_non_numbers(line, p);
            p += u;

            a[i] = line.substring(from, from + n );
        }

        return a;
    }

    private void add(int lines, String s) {
        combos.append(lines);
        combos.append(COMMA);
        combos.append(s);
        combos.append(SEPARATOR);
        count += 1;
    }

    private void clear(String s, int r) {
        combos = new StringBuffer();
        count = 0;
        scope = false;

        split = r;
        whose = s;
    }

    private void listing() {
        if(split == 0) {
            return;
        }

        switch(count) {
        case 0:
            return;
        default:
            break;
        }

        int q;
        String head;
        String tail = combos.toString();
        for(;;) {
            q = tail.indexOf(SEPARATOR);
            if(q >= 0) {
                head = tail.substring(0, q);
                q += SEPARATOR_SIZE;
                tail = tail.substring(q);

                buffer.append(head);
                buffer.append(COMMA);
                if(scope) {
                    buffer.append(ALL_QP);
                } else {
                    buffer.append(EMPTY);
                }

                buffer.append(whose); // whose = lineType.common();
                buffer.append(NEW_LINE);
                total += 1;
                q = sequence_of_non_numbers(tail, 0);
                tail = tail.substring(q);
            } else {
                break;
            }

        }

    }

    public TableCsv(int r, boolean s, boolean w) {
        buffer = new StringBuffer();
        rowCount = r;
        serialNumber = s;
        total = 0;
        whoText = w;

        csv = new String[rowCount];
        for(int i = 0; i < rowCount; ++i) {
            csv[i] = TILDE; // Software can concentrate on the first part of the csv array because if sorted, numbers precede TILDE.
        }

        NEW_LINE = System.getProperty("line.separator");
        NEW_LINE_LENGTH = NEW_LINE.length();
        clear(EMPTY, 0); // combos = new StringBuffer();
    }

    public boolean run(String fileName) {
        String s;

        try {
            BufferedReader buffered = new BufferedReader( new FileReader(fileName) );
            s = buffered.readLine();
// Line-1
            if( s.length() >= STANDARD_LINE_LENGTH ) {
                draw = dividing(s);
            } else {
                error = "e58(Line-1): " + String.valueOf( s.length() ) + " <= STANDARD_LINE_LENGTH";
                return false;
            }

            Characterizable lineType;
            int b, howMany, r;
            String extra;

            if(whoText) {
                timeNameText = WHO_TEXT;
            } else {
                TimeName wt = new TimeName(WHO, CSV_FILE);
                timeNameText = wt.temporaryName(serialNumber);
                System.out.println(timeNameText);
            }

            for(;;) {
                s = buffered.readLine();
                if(s == null) {
                    break;
                }

                scope = allQP(s);
                if( s.length() >= STANDARD_LINE_LENGTH ) {
                    lineType = new DateFollowed(s);
                    r = lineType.dateLine();

                    if(r > 0) {
                        listing();

                        s = lineType.common();
                        clear(s, r);
                        continue;
                    }

                    a = dividing(s);
                } else {
                    continue;
                }

                howMany = countBalls(s);
                if(howMany > 0) {
                    s = assembling(); // a[i]
                    add(howMany, s);
                }

            }

            buffered.close();
            listing();
            openSaveClose(timeNameText);
            sorting(timeNameText, SORT_IN_REVERSE_ORDER);
            return true;
        } catch(IOException e42) {
            error = "IOException e42: " + fileName;
            return false;
        }

    }

    public String csvName() {
        return timeNameText;
    }

    public String inquiry() {
        return error;
    }

    public String[] csvList() {
        return table;
    }

    public String[] drawArray() {
        return draw;
    }

}
