package info.lotosummary.software;
import java.io.*;
import java.util.*;

public class TimeName {
    static final String HYPHEN = "-";
    static final String SERIAL_TEXT = "serial.txt";
    static final int NOT_CONVERTED = -1;
    Singleton singleton;
    String base, extension, error, name, timeName;
    int minute, second;

    private int integerFromString(String s) {
        int result;

        try {
            result = Integer.parseInt(s);
            return result;
        } catch(NumberFormatException e20) {
            error = "NumberFormatException e20";
            return NOT_CONVERTED;
        }

    }

    public TimeName(String b, String e) {
        base = b;
        extension = e;
        name = base;
        singleton = Singleton.getInstance();
        readSerialNumber();
    }

    public String getTimeName() {
        return timeName;
    }

    public void readSerialNumber() {
        String s;

        try {
            BufferedReader buffered = new BufferedReader( new FileReader(SERIAL_TEXT) );

            s = buffered.readLine();
            if(s == null) {
                zeroSerialNumber();
                return;
            }

            int data = integerFromString(s);
            singleton.setTo(data);
            buffered.close();
        } catch(IOException e25) {
            error = "IOException e25";
            zeroSerialNumber();
        }

    }

    public boolean setSerialNumber() {
// Producing a new serial number
        int sn = singleton.increment();

        try {
// Writing the serial number
            BufferedWriter file = new BufferedWriter( new FileWriter(SERIAL_TEXT) );
            file.write( String.valueOf(sn) );
            file.newLine();
            file.close();

// First part of a file name
            StringBuffer h = new StringBuffer();
            h.append(base);
            h.append(sn);
            h.append(HYPHEN);
            name = h.toString();
            return true;

        } catch(IOException e6) {
            error = "IOException e6";
            return false;
        }

    }

    public String temporaryName(boolean serial) {
        Calendar now = Calendar.getInstance();
        minute = now.get(now.MINUTE);
        second = now.get(now.SECOND);

        if(serial) {
            setSerialNumber();
        }

        StringBuffer h = new StringBuffer();
        h.append(name);
        h.append(minute);
        h.append(HYPHEN);
        h.append(second);
        h.append(extension);
        String ti = h.toString();
        if(ti == timeName) {
            setSerialNumber();

            StringBuffer y = new StringBuffer();
            y.append(name);
            y.append(minute);
            y.append(HYPHEN);
            y.append(second);
            y.append(extension);
            ti = y.toString();
        }

        timeName = ti;
        return timeName;
    }

    public boolean zeroSerialNumber() {
// Producing a new serial number
        int sn = 0;

        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(SERIAL_TEXT) );
            file.write( String.valueOf(sn) );
            file.newLine();
            file.close();

            StringBuffer h = new StringBuffer();
            h.append(base);
            h.append(sn);
            h.append(HYPHEN);
            name = h.toString();
            return true;

        } catch(IOException e36) {
            error = "IOException e36";
            return false;
        }

    }

}

