package info.lotosummary.software;
import java.io.*;

public class ZokoBonus {
    static final int ALL_QP_SIZE = 6;
    static final int DRAW_ARRAY_SIZE = 12;
    static final int STANDARD_LINE_LENGTH = 20; // "07 14 20 24 28 32 37"
    static final String ALL_QP = "ALL QP";
    static final String ANCHOR = ">>";
    static final String EMPTY = "";
    static final String GAP = " ";
    static final String ID_COLON = " ID:";
    static final String N_0TO9 = "0123456789";
    static final String QP = "QP";
    static final String SLASH = "/";
    static final String SPACE = "@";
    static final String TEXT_FILE = ".txt";
    static final String WHO = "who";
    static final String WHO_TEXT = "who.txt";

    boolean noSplitting, oneMore, scope, serialNumber, whoText;
    int count, balls, NEW_LINE_LENGTH, split;
    String drawLine, error, id, NEW_LINE, res_no, whose;
    String[] a = {"", "", "", "", "", "", "", "", "", "", "", ""};
    String[] draw = {"", "", "", "", "", "", "", "", "", "", "", ""};
    StringBuffer buffer;
    StringBuffer combos;

    private boolean allQP(String s) {
        if(scope) {
            return true;
        }

        int q = s.indexOf(ALL_QP);
        if(q >= 0) {
            scope = true;
        }

        return scope;
    }

    private boolean openSaveClose(String fileName) {
        String s = buffer.toString();
        int size = s.length();
        String c;

// Trimming
        for(int i = 0; i < size; i += NEW_LINE_LENGTH) {
            c = s.substring(i, i + NEW_LINE_LENGTH );
            if( NEW_LINE.equals(c) ) {
                continue;
            } else {
                s = s.substring(i);
                break;
            }

        }

// Writing
        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(fileName) );
            file.write(s); file.newLine();
            file.close();
            return true;
        } catch (IOException e26) {
            error = "IOException e26: " + fileName;
            return false;
        }

    }

    private boolean countBalls(String s) {
        int count = 0;
        int q;

        q = s.indexOf(draw[1]);
        if(q >= 0) {
            count += 1;
        }

        q = s.indexOf(draw[2]);
        if(q >= 0) {
            count += 1;
        }

        q = s.indexOf(draw[3]);
        if(q >= 0) {
            count += 1;
        }

        q = s.indexOf(draw[4]);
        if(q >= 0) {
            count += 1;
        }

        q = s.indexOf(draw[5]);
        if(q >= 0) {
            count += 1;
        }

        q = s.indexOf(draw[6]);
        if(q >= 0) {
            count += 1;
        }

        q = s.indexOf(draw[7]);
        if(q >= 0) {
            count += 1;
        }

        if(count != balls) {
            return false;
        }

// Counting the bonus ball
        q = s.indexOf(draw[8]);
        if(q >= 0) {
            return true;
        }

        q = s.indexOf(draw[9]);
        if(q >= 0) {
            return true;
        }

        return false;
    }

    private int sequenceOfNumbers(String line, int p) {
        int count = 0;
        int q;
        int size = line.length();
        String c;
        for(int i = p; i < size; ++i) {
            c = line.substring(i, i + 1 );
            q = N_0TO9.indexOf(c);
            if(q >= 0) {
                count += 1;
                continue;
            } else {
                break;
            }

        }

        return count;
    }

    private int sequence_of_non_numbers(String line, int p) {
        int count = 0;
        int q;
        int size = line.length();
        String c;
        for(int i = p; i < size; ++i) {
            c = line.substring(i, i + 1 );
            q = N_0TO9.indexOf(c);
            if(q >= 0) {
                break;
            } else {
                count += 1;
                continue;
            }

        }

        return count;
    }

    private String assembling() {
        StringBuffer os = new StringBuffer();

        for(int i = 1; i < DRAW_ARRAY_SIZE; ++i) {
            if( a[i].length() > 0 ) {
                os.append(a[i]);
                os.append(GAP);
            }

        }

        String s = os.toString();
        return s;
    }

    private String standardLine1() {
        StringBuffer os = new StringBuffer();
        os.append(draw[1]);
        os.append(GAP);
        os.append(draw[2]);
        os.append(GAP);
        os.append(draw[3]);
        os.append(GAP);
        os.append(draw[4]);
        os.append(GAP);
        os.append(draw[5]);
        os.append(GAP);
        os.append(draw[6]);
        os.append(GAP);
        os.append(draw[7]);
        os.append(GAP);
        String s = os.toString();

        return s;
    }

    private String[] dividing(String line) {
        String[] a = {"", "", "", "", "", "", "", "", "", "", "", ""};
        int from = 0;
        int n, u;
        int p = 0;

        for(int i = 1; i < DRAW_ARRAY_SIZE; ++i) {
            n = sequenceOfNumbers(line, p);
            from = p;
            p += n;

            u = sequence_of_non_numbers(line, p);
            p += u;

            a[i] = line.substring(from, from + n );
        }

        return a;
    }

    private void add(String s) {
        combos.append(s);
        combos.append(NEW_LINE);
        count += 1;
    }

    private void clear(String i, String re, String s, int r) {
        combos = new StringBuffer();
        count = 0;
        scope = false;

        id = i;
        res_no = re;
        split = r;
        whose = s;
    }

    private void listing() {
        boolean pile = false;
        int q;
        String chopped, head, tail;
        String combosList = combos.toString();

        if(split == 0) {
            buffer.append(NEW_LINE);
            buffer.append(ANCHOR);
            buffer.append(whose);
            buffer.append(NEW_LINE);
            buffer.append(combosList);
            return;
        }

        switch(count) {
        case 0:
            return;
        case 1:
            break;
        default:
            pile = true;
            break;
        }

        if(pile || noSplitting) {
            if(oneMore) {
                buffer.append(NEW_LINE);
                oneMore = false;
            }

            if(scope) {
                q = combosList.indexOf(ALL_QP);
                if(q >= 0) {
                    buffer.append(NEW_LINE);
                    buffer.append(ANCHOR);
                    buffer.append(whose);
                    buffer.append(NEW_LINE);
                    buffer.append(combosList);
                } else {
                    q = combosList.length() - NEW_LINE_LENGTH;
                    chopped = combosList.substring(0, q);
                    buffer.append(NEW_LINE);
                    buffer.append(ANCHOR);
                    buffer.append(whose);
                    buffer.append(NEW_LINE);
                    buffer.append(chopped);
                    buffer.append(SPACE);
                    buffer.append(ALL_QP);
                    buffer.append(NEW_LINE);
                }

            } else {
                buffer.append(NEW_LINE);
                buffer.append(ANCHOR);
                buffer.append(whose);
                buffer.append(NEW_LINE);
                buffer.append(combosList);
            }

        } else {
// Splitting the date line
            q = combosList.length() - NEW_LINE_LENGTH;
            chopped = combosList.substring(0, q);
            oneMore = true;

            if(scope) {
                q = chopped.indexOf(ALL_QP);
                if(q >= 0) {
                    head = chopped.substring(0, q);
                    q += ALL_QP_SIZE;
                    tail = chopped.substring(q);
                    chopped = head + tail;
                }

                buffer.append(res_no);
                buffer.append(chopped);
                buffer.append(GAP);
                buffer.append(QP);
                buffer.append(id);
            } else {
                buffer.append(res_no);
                buffer.append(chopped);
                buffer.append(id);
            }

        }

    }

    public ZokoBonus(int b, boolean n, boolean s, boolean w) {
        buffer = new StringBuffer();
        balls = b;
        noSplitting = n;
        oneMore = false;
        serialNumber = s;
        whoText = w;

        NEW_LINE = System.getProperty("line.separator");
        NEW_LINE_LENGTH = NEW_LINE.length();
        clear(EMPTY, EMPTY, EMPTY, 0); // combos = new StringBuffer();
    }

    public boolean run(String fileName) {
        String s;

        try {
            BufferedReader buffered = new BufferedReader( new FileReader(fileName) );
            s = buffered.readLine();
// Line-1
            if( s.length() >= STANDARD_LINE_LENGTH ) {
                draw = dividing(s);
                drawLine = standardLine1();
            } else {
                error = "e60(Line-1): " + String.valueOf( s.length() ) + " <= STANDARD_LINE_LENGTH";
                return false;
            }

            Characterizable lineType;
            int b, howMany, r;
            String extra, id, res_no, timeNameText;
            StringBuffer os;

            if(whoText) {
                timeNameText = WHO_TEXT;
            } else {
                TimeName wt = new TimeName(WHO, TEXT_FILE);
                timeNameText = wt.temporaryName(serialNumber);
                System.out.println(timeNameText);
            }

            for(;;) {
                s = buffered.readLine();
                if(s == null) {
                    break;
                }

                scope = allQP(s);
                if( s.length() >= STANDARD_LINE_LENGTH ) {
                    lineType = new DateFollowed(s);
                    r = lineType.dateLine();

                    if(r > 0) {
                        listing();

                        id = lineType.name_id();
                        res_no = lineType.anchor_res_no();
                        clear(id, res_no, s, r);
                        continue;
                    }

                    a = dividing(s);
                } else {
                    continue;
                }

                if( countBalls(s) ) {
                    s = assembling();
                    add(s);
                }

            }

            buffered.close();
            listing();
            openSaveClose(timeNameText);
            return true;
        } catch(IOException e27) {
            error = "IOException e27: " + fileName;
            return false;
        }

    }

    public String inquiry() {
        return error;
    }

    public String whoTextLine1() {
        return drawLine;
    }

}
